Loading...
Searching...
No Matches
BALL::ParamFile Class Reference

`#include <BALL/FORMAT/paramFile.h>`

Inheritance diagram for BALL::ParamFile:

## Classes

struct | ParameterDescription

## Public Types

enum | ParameterType { INFILE , OUTFILE , STRING , INT , DOUBLE , INFILELIST , OUTFILELIST , STRINGLIST , INTLIST , DOUBLELIST , GALAXY_OPT_OUTDIR , GALAXY_OPT_OUTID }
Public Types inherited from BALL::File
typedef std::ios::openmode | OpenMode
enum | Transformation { TRANSFORMATION__EXEC = 1 , TRANSFORMATION__FILTER = 2 , TRANSFORMATION__URL = 3 }
enum | Type { TYPE__UNKNOWN = 0 , TYPE__DIRECTORY = 1 , TYPE__CHAR_SPECIAL_FILE = 2 , TYPE__BLOCK_SPECIAL_FILE = 3 , TYPE__REGULAR_FILE = 4 , TYPE__SYMBOLIC_LINK = 5 , TYPE__SOCKET = 6 , TYPE__FIFO_SPECIAL_FILE = 7 }

## Public Member Functions

| ParamFile (const String &name, File::OpenMode open_mode)
| ~ParamFile ()
void | writeSection (String section_name, String section_description, String version, const String &section_helptext, const String &category, const std::list< std::pair< String, ParameterDescription > > &descriptions, const std::map< String, list< String > > &values)
void | readSection (String &tool_name, String &section_description, String &version, String &section_helptext, String &category, std::list< std::pair< String, ParameterDescription > > &descriptions, std::map< String, list< String > > &values, bool overwrite_existing=false)
void | close ()
Public Member Functions inherited from BALL::File
| File ()
| File (const String &name, OpenMode open_mode=std::ios::in)
virtual | ~File ()
virtual void | clear ()
bool | isValid () const
bool | open (const String &name, File::OpenMode open_mode=std::ios::in)
bool | reopen ()
bool | reopen (File::OpenMode open_mode)
void | close ()
const String & | getName () const
void | setName (const String &name)
const String & | getOriginalName () const
Size | getSize ()
File::OpenMode | getOpenMode () const
Type | getType (bool trace_link) const
bool | copyTo (const String &destination_name, Size buffer_size=4096)
bool | moveTo (const String &destination_name)
bool | remove ()
bool | renameTo (const String &new_path)
bool | truncate (Size size=0)
std::fstream & | getFileStream ()
TransformationManager & | getTransformationManager ()
const TransformationManager & | getTransformationManager () const
bool | operator== (const File &file) const
bool | operator!= (const File &file) const
bool | isOpen () const
bool | isClosed () const
bool | isAccessible () const
bool | isCanonized () const
bool | isReadable () const
bool | isWritable () const
bool | isExecutable () const

## Static Public Member Functions

static String | buildNestedParameterName (const String &category, const String &parameter_name)
static Size | parseNestedParameterName (const String &parameter_name, String string_array[])
static Size | getSize (String name)
static Type | getType (String name, bool trace_link)
static bool | copy (String source_name, String destination_name, Size buffer_size=4096)
static bool | move (const String &source_name, const String &destination_name)
static bool | remove (String name)
static bool | rename (String old_path, String new_path)
static bool | truncate (String path, Size size=0)
static bool | createTemporaryFilename (String &temporary, const String &suffix=".TMP")
static void | enableTransformation (Transformation transformation)
static void | disableTransformation (Transformation transformation)
static bool | isTransformationEnabled (Transformation transformation)
static void | registerTransformation (const String &pattern, const String &exec)
static void | unregisterTransformation (const String &pattern)
static bool | isAccessible (String name)
static bool | isReadable (String name)
static bool | isWritable (String name)
static bool | isExecutable (String name)

## Protected Attributes

String | filename_
File::OpenMode | open_mode_
bool | mode_read_
QXmlStreamReader * | xmlIn_
QXmlStreamWriter * | xmlOut_
QFile * | file_
String | name_
String | original_name_
OpenMode | open_mode_
bool | is_open_
bool | is_temporary_

## Additional Inherited Members

Static Public Attributes inherited from BALL::File
static const OpenMode | MODE_IN
| Open for input (default).
static const OpenMode | MODE_OUT
| Open for output.
static const OpenMode | MODE_APP
| Append. Seek to end before each write operation.
static const OpenMode | MODE_BINARY
| Binary mode.
static const OpenMode | MODE_ATE
| Seek to end directly after opening.
static const OpenMode | MODE_TRUNC
| Truncate an existing file.
static const String | TRANSFORMATION_EXEC_PREFIX
| Prefix for filenames that are created through the execution of commands "exec:".
static const String | TRANSFORMATION_FILE_PREFIX
| Prefix for files (to mimick URL-like behavior) "file:".
static const String | TRANSFORMATION_FTP_PREFIX
| Prefix for FTP-transfers "ftp://".
static const String | TRANSFORMATION_HTTP_PREFIX
| Prefix for HTTP-transfer "http://".
static HashSet< String > | created_temp_filenames_
static TransformationManager | transformation_manager_
static Size | transformation_methods_

## Detailed Description

Class for storing and retrieving parameters (e.g. tool-parameters) to an xml-based file

Definition at line 23 of file paramFile.h.

## Member Enumeration Documentation

## ParameterType

enum BALL::ParamFile::ParameterType

Enumerator
INFILE |
OUTFILE |
STRING |
INT |
DOUBLE |
INFILELIST |
OUTFILELIST |
STRINGLIST |
INTLIST |
DOUBLELIST |
GALAXY_OPT_OUTDIR |
GALAXY_OPT_OUTID |

Definition at line 27 of file paramFile.h.

## Constructor & Destructor Documentation

## ParamFile()

BALL::ParamFile::ParamFile | ( | const String & | name,
|  | File::OpenMode | open_mode )

## ~ParamFile()

BALL::ParamFile::~ParamFile | ( |  | ) |

## Member Function Documentation

## buildNestedParameterName()

String BALL::ParamFile::buildNestedParameterName | ( | const String & | category,
|  | const String & | parameter_name )

static

From category, parameter_name builds [category]:[parameter_name]

## close()

void BALL::ParamFile::close | ( |  | ) |

## parseNestedParameterName()

Size BALL::ParamFile::parseNestedParameterName | ( | const String & | parameter_name,
|  | String | string_array[] )

static

Returns [category, parameter] from [category]:[parameter]

## readSection()

void BALL::ParamFile::readSection | ( | String & | tool_name,
|  | String & | section_description,
|  | String & | version,
|  | String & | section_helptext,
|  | String & | category,
|  | std::list< std::pair< String, ParameterDescription > > & | descriptions,
|  | std::map< String, list< String > > & | values,
|  | bool | overwrite_existing = false )

Read a section from input file (e.g. parameters for one tool)

Parameters

  descriptions | descriptions of parameters will be stored here
  values | values of parameters will be stored here
  overwrite_existing | if set to true, entries already existing in 'descriptions' and 'values' will be overwritten.

## writeSection()

void BALL::ParamFile::writeSection | ( | String | section_name,
|  | String | section_description,
|  | String | version,
|  | const String & | section_helptext,
|  | const String & | category,
|  | const std::list< std::pair< String, ParameterDescription > > & | descriptions,
|  | const std::map< String, list< String > > & | values )

Write a section to the output file (e.g. parameters for one tool)

Parameters

  section_description | a short description of this section (e.g. the tool), containing only a few words
  section_helptext | a longer help-text/detailed description can be specified here
  category | the category into which the tool falls (e.g. Docking, QSAR, etc.)
  descriptions | description for all parameters to be saved
  value | values of all parameters to be saved

## Member Data Documentation

## file_

QFile* BALL::ParamFile::file_

protected

Definition at line 117 of file paramFile.h.

## filename_

String BALL::ParamFile::filename_

protected

Definition at line 112 of file paramFile.h.

## mode_read_

bool BALL::ParamFile::mode_read_

protected

Definition at line 114 of file paramFile.h.

## open_mode_

File::OpenMode BALL::ParamFile::open_mode_

protected

Definition at line 113 of file paramFile.h.

## xmlIn_

QXmlStreamReader* BALL::ParamFile::xmlIn_

protected

Definition at line 115 of file paramFile.h.

## xmlOut_

QXmlStreamWriter* BALL::ParamFile::xmlOut_

protected

Definition at line 116 of file paramFile.h.